/*  GadTools layout toolkit
**
**  Copyright  1993-1994 by Olaf `Olsen' Barthel
**  Freely distributable.
*/

#include "gtlayout_global.h"

STATIC VOID __regargs
LTP_UpdateStrings(register ObjectNode *Group)
{
	ObjectNode	*Node;
	ULONG		 Page;

	SCANPAGE(Group,Node,Page)
	{
		switch(Node -> Type)
		{
			case FRACTION_KIND:
			case PASSWORD_KIND:
			case STRING_KIND:
			case INTEGER_KIND:

				if(Node -> Host)
					LTP_PutStorage(Node);

				break;

			case GROUP_KIND:

				LTP_UpdateStrings(Node);
				break;
		}
	}
}

VOID LIBENT
LT_UpdateStrings(REG(a0) LayoutHandle *Handle)
{
	if(Handle)
		LTP_UpdateStrings(Handle -> TopGroup);
}
